'
'
'
'         ###############
'       ###################
'      ###               ###
'     ###    ###          ###
'    ###    ## ##         ###
'    ###   ##   ##        ###
'    ###  ##     ##       ###
'    ###  ##      ##      ###
'    ###  ##      ##      ###
'    ###   ####  ##      ###
'     ###    ####       ###
'      ###             ###
'       ###           ###
'         #############
'           #########




string kernel_funs="

'======================
'>>O2H LOW LEVEL MACROS
'======================


#view 18 ###
#endv 18 ###
version 18 `version`
true 18 -1
false 18 0
use 18 include once
uses 18 include once
using 18 include once
global 18 dim static 'global is deprecated
lobyte 18 ((%1) and 0xff)
loword 18 ((%1) and 0xffff)
hibyte 18 (((%1)>>8) and 0xff)
hiword 18 (((%1)>>16) and 0xffff)
redim 18
      #ifndef %2
        dim static string %2_buffer = ``
        dim static int %2_count
        dim static %1 byref %2
      #endif
      scope
      dim sys %2_qb = %3
      dim sys %2_le = len %2_buffer
      dim sys %2_qn = %2_le / sizeof(%1)
      if %2_qb > %2_qn
        %2_buffer += nuls( sizeof(%1) * (%2_qb - %2_qn))
      elseif %2_qb <  %2_qn
        %2_buffer = left( %2_buffer, sizeof(%1) * %2_qb )
      end if
      %2_count=%3
      @%2=strptr(%2_buffer)
      end scope
del 18 
      #if typecodeof(%1)>0x200
        #ifdef %1.destructor
          %1.destructor
        #endif
        freememory @%1 : @%1=0
      #elseif typecodeof(%1)>0xe0
        freememory strptr(%1) : if ?%1 { *%1=0 : ?%1=0 }
      #elseif typecodeof(%1)>0xc0
        freememory strptr(%1) : ?%1=0
      #elseif typecodeof(%1)>0xa0
        #error Not a dynamic string: %1
      #else
        #error Not a string or object: %1
      #endif
new 18 %1 * %2 = getmemory sizeof %1
      #ifdef %1.___
      ? %2 = @%1_table
      #endif
      #ifdef %1.constructor
        %2.constructor(%3)
      #endif




'===============================
'>>O2H SYSTEM TERMINATION MACROS
'===============================



terminate 19 |go 0 [ebx+2448] : |go 0 [ebx+2144]
freestrings 19 |go 0 [ebx+2144]
freelibs 19 |go 0 [ebx+2448]



'=======================
'>>O2H HIGH LEVEL MACROS
'=======================

right 20 right(s,i) {mid(s,-(i))}
guidbin 20 guidbin(s) {byval guidval(guid{},s)}

'========================
'>>O2 LOW LEVEL FUNCTIONS
'========================


getmemory 4 8
freememory 4 16
loadlibrary 4 24
freelibrary 4 32
getprocaddress 4 40
copy0 4 56
copy00 4 64
copyn 4 72
copy 4 72
mbox 4 2048 'mboxa
comparestr 4 2192 ' comps ' COMPARING BSTRS


'=============================
'>>COMMON RESERVED WORDS
'=============================

exit   9 1
repeat 9 1
call   9 1
jmp    9 1
and    9 0
or     9 0
xor    9 0
not    9 1
null   9 1



'===========================
'>>O2 ATTRIBUTE MACROS
'===========================



sizeof      11 1 4
offsetof    11 2 4
countof     11 3 4
spanof      11 3 4
bytesof     11 4 4
typeof      11 5 193
structureof 11 6 193
encodingof  11 6 193
prototypeof 11 7 193
typecodeof  11 8 4
recordof    11 9 4
widthof    11 10 4
strptr      11 21 8


'===========================
'>>O2 KEYWORDS
'===========================




incl 13 1


#semicolon 13 2
retn 13 4
skip 13 6
with 13 7
o2 13 10
bind 13 12
enum 13 14
def 13 15
#def 13 15
type 13 16
struct 13 11
class 13 13
var 13 17
include 13 18
#include 13 18
packed 13 21
_def 13 22
namespace 13 23
restore 13 24
rem 13 26
includepath 13 30
librarypath 13 31
#file 13 34
embedfile 13 35
quote 13 36
typedef 13 37
union 13 38
#case 13 41
#lookahead 13 43
#autodim 13 44
#alert 13 46
#error 13 47
#pragma 13 48
#unique 13 49
#console 13 50
#show 13 51 
#emit 13 52 
addr 13 53 
#compact 13 54 
#cpointer 13 55 



'===========================
'>>O2H KEYWORDS
'===========================

let 14 2
dim 14 4
const 14 4
local 14 5
static 14 6
! 14 8
declare 14 8
function 14 9
sub 14 10
method 14 11
loop 14 12 'LOOP'` KEYWORD DISTINGUISHED FROM ASM LOOP
if 14 13
then 14 14
else 14 15
elseif 14 16
endif 14 17
enddo 14 18
endwhile 14 19
endsel 14 20 'ALSO: END SELECT
do 14 21
while 14 23
wend 14 24
exit 14 25
redo 14 26
continue 14 26
repeat 14 26
default 14 27
break  14 28
switch 14 29
select 14 29
case 14 30
for 14 31
to 14 32
step 14 33
next 14 34
goto 14 35
gosub 14 36
methods 14 37
return 14 38
% 14 39 ' QB style equate
$ 14 39 ' QB style equate
block 14 41
scope 14 42
indexbase 14 44
lib 14 45
library 14 45
extern 14 48
that 14 49
this 14 50
#noprec 14 53
#noinit 14 54
#byval 14 55
#byref 14 56
#dim 14 57
#assign 14 58
readstate 14 60
deff 14 62
'operations 14 63


'============
'METACOMMANDS
'============


#if 13 100
#else 13 101
#elseif 13 102
#endif 13 103
#define 13 104
#ifdef 13 105
#ifndef 13 106
undef 13 107
#undef 13 107
#undefine 13 107
alias 13 108 'thinBasic headers
macro 13 109
#print 13 110
'#ifexist 13 111
'#ifnexist 13 112
#eval 13 113
#blockdepth 13 201
#recordof 13 202
#list 13 203


'================================
'primitives (Basic and C style
'================================


void      15 &h00 '*
sbyte     15 &h01
byte      15 &h21
ubyte     15 &h21
string    15 &he1
string2   15 &he2
wstring   15 &he2
bstring   15 &hc1
gstr_     15 &hc1 '* Accept any Bstring width. for core functions only
bstr      15 &hc1
bstring2  15 &hc2
char      15 &ha1
wchar     15 &ha2
cstr_     15 &ha1 '* Accept any string width. for core functions only
asciiz    15 &ha1
zstring   15 &ha1
zstring2  15 &ha2
asciiz2   15 &ha2
short     15 &h02
long      15 &h04
wide      15 &ha2
int       15 &h04
integer   15 &h04
float     15 &h64
single    15 &h64
double    15 &h68
extended  15 &h6A
quad      15 &h48 '* using FPU on 32 bit systems (was 08), returns data on edx:eax
word      15 &h22
dword     15 &h24
ulong     15 &h24
uint      15 &h24
any       15 &h08 '* to be used by reference only
sys       15 &h08 '* 4/8 depending on 32/64 bit system
bool      15 &h04 '* MS
boolean   15 &h01 '* MS
fpu       15 &h40 '* fast call using fpu registers (not exportable)
signed    15 &h04
unsigned  15 &h24
qword     15 &h28 '* Assembler only



'===========================================
'>>OVERLOADABLE INTEGER AND STRING FUNCTIONS
' overloadable functions -16
' integer and string
' TREATED AS STDCALL
'===========================================



news 16 ##sys@0 bstr 08
frees 16 ##gstr_#@0 sys 16 ##sys@0 sys 16
error 16 ##@ bstr 128
nuls 16 ##sys@0 bstr 08
compile 16 ##string@0 sys 368
val 16 ##zstring@1 fpu 192
valat 16 ##sys@0 fpu 192
ltrim 16 ##string@0 bstr 2312
rtrim 16 ##string@0 bstr 2320
lcase 16 ##string@0 bstr 2328
ucase 16 ##string@0 bstr 2336
stringbytes 16 ##sys#sys@00 bstr 2464
string 16 ##sys#zstring@00 bstr 2472 ##sys#string@00 bstr 2480
space 16 ##sys@0 bstr 2488
left 16 ##gstr_#sys@00 bstr 2344 ##cstr_#sys@10 bstr 2400
mid 16 +_
      ##gstr_#sys#sys@000 bstr 2360 ##cstr_#sys#sys@100 bstr 2392 +_
      ##gstr_#sys@00 bstr 2416 ##cstr_#sys@10 bstr 2424 
      ''mid command
_mid 16 ##gstr_#sys#gstr_@000 sys 2456 ##cstr_#sys#gstr_@100 sys 2352 
instr 16 ##string#string@00 sys 2504 ##sys#string#string@000 sys 320
getfile 16 ##cstr_@1 bstr 336 ##cstr_#gstr_@11 sys 2512
putfile 16 ##cstr_#gstr_@10 sys 344
print 16 ##cstr_@1 sys 2496
asc 16 ##string@0 sys 2432 ##string#sys@00 sys 2368
unic 16 ##wstring@0 sys 2536 ##wstring#sys@00 sys 2528
len 16 ##gstr_@0 sys 2376 ##cstr_@1 sys 2408
chr 16 ##sys@0 bstr 2384
wchr 16 ##sys@0 bstring2 2544
str 16 ##fpu@0 bstr 2520 ##fpu#sys@00 bstr 200 
hex 16 ##fpu#sys@00 bstr 216 ##fpu@0 bstr 208 
guidval 16 ##guid#bstr@10 sys 352  ##guid#zstring@11 sys 352
guidtxt 16 ##guid@1 bstr 360
numberformat 16 ##sys#sys#sys#sys#sys#sys@000000 sys 2552 ##@ sys 2560 


'===========================
'>>FLOATING POINT MACRO
' macro function
'===========================


abs 17 fabs
acos 17 fld st0 : fmul st0 : fld1 : fsubp st1,st0 : fchs : fsqrt : fxch : fpatan
asin 17 fld st0 : fmul st0 : fld1 : fsubp st1,st0 : fchs : fsqrt : fpatan
atan  17 fpatan
atn 17 fld1 : fpatan
cos 17 fcos
deg 17 fldpi : fdivp st1 : |sp -8 : mov [esp],180 : fimul dword [esp] : |sp 8
frac 17 fld1 : fxch : fprem : fstp st1
hypot 17 fmul st0 : fxch : fmul st0 : faddp st1 : fsqrt
lin 17 fldln2 : fxch : fyl2x
log 17 fldln2 : fxch : fyl2x
log2 17 fld1 : fxch : fyl2x
log10 17 fldlg2 : fxch : fyl2x
logn 17 fld1 : fxch st1 : fyl2x : fld1 : fdivrp st1 : fxch st1 : fyl2x
mod 17 fxch st1 : fprem : fstp st1
pi 17 fldpi
exp 17 +exponents
pow 17 +powers
rad 17 fldpi : fmulp st1 : |sp -8 : mov [esp],180 : fidiv dword [esp] : |sp 8
recip 17 fld1 : fdivrp
round 17 frndint
sgn 17 fldz : fcomip : ( :  jnz exit : fldz : jmp fwd _sd : ) : +_
       ( : ja exit : fld1 : jmp fwd _sd : ) : ( : jb exit : fld1 : fchs : jmp fwd _sd : ) : +_
      ._sd : fxch : fstp st0
sin 17 fsin
sqr 17 fsqrt
sqrt 17 fsqrt
tan 17 fptan : fstp st0
floor 17 |sp -8 : fstcw [esp] : fstcw [esp+4] : and word [esp],0xf3ff : or word [esp],0x400 : fldcw [esp]
      frndint : fldcw [esp+4] : |sp 8
ceil 17 |sp -8 : fstcw [esp] : fstcw [esp+4] : and word [esp],0xf3ff : or word [esp],0x800 : fldcw [esp]
      frndint : fldcw [esp+4] : |sp 8
trunc 17 |sp -8 : fstcw [esp] : fstcw [esp+4] : or word [esp],0xc00 : fldcw [esp]
      frndint : fldcw [esp+4] : |sp 8


'===========================

 ,0,0 'mark end of data

'===========================
'>>REGISTERS
'===========================

x86_registers:

' regsize regno regtype

al    10 101
cl    10 111
dl    10 121
bl    10 131
ah    10 141
ch    10 151
dh    10 161
bh    10 171
'---------------------------
ax    10 201
cx    10 211
dx    10 221
bx    10 231
sp    10 241
bp    10 251
si    10 261
di    10 271
'---------------------------
eax   10 401
ecx   10 411
edx   10 421
ebx   10 431
esp   10 441
ebp   10 451
esi   10 461
edi   10 471
'---------------------------
st0   10 A02
st1   10 A12
st2   10 A22
st3   10 A32
st4   10 A42
st5   10 A52
st6   10 A62
st7   10 A72
'---------------------------
mmx0  10 F03 
mmx1  10 F13 
mmx2  10 F23 
mmx3  10 F33 
mmx4  10 F43 
mmx5  10 F53 
mmx6  10 F63 
mmx7  10 F73 
'---------------------------  
xmm0  10 F04
xmm1  10 F14
xmm2  10 F24
xmm3  10 F34
xmm4  10 F44
xmm5  10 F54
xmm6  10 F64
xmm7  10 F74
xmm8  10 F84
xmm9  10 F94
xmm10 10 FA4
xmm11 10 FB4
xmm12 10 FC4
xmm13 10 FD4
xmm14 10 FE4
xmm15 10 FF4
'---------------------------
cr0   10 405 '129  
cr2   10 415 
cr3   10 425 
cr4   10 435 
'---------------------------
dr0   10 406 '130  
dr1   10 416 
dr2   10 426 
dr3   10 436 
dr4   10 446
dr5   10 456 
dr6   10 466 
dr7   10 476 
'---------------------------
es    10 407'131  
cs    10 417 
ss    10 427 
ds    10 437 
fs    10 447
gs    10 457 
'---------------------------
'64 bit mode registers
'---------------------------
rax   10 809
rcx   10 819
rdx   10 829
rbx   10 839
rsp   10 849
rbp   10 859
rsi   10 869
rdi   10 879
r8    10 889
r9    10 899
r10   10 8A9
r11   10 8B9
r12   10 8C9
r13   10 8D9
r14   10 8E9
r15   10 8F9
'---------------------------
r8l   10 489
r9l   10 499
r10l  10 4A9
r11l  10 4B9
r12l  10 4C9
r13l  10 4D9
r14l  10 4E9
r15l  10 4F9
'---------------------------
r8w   10 289
r9w   10 299
r10w  10 2A9
r11w  10 2B9
r12w  10 2C9
r13w  10 2D9
r14w  10 2E9
r15w  10 2F9
'---------------------------
r8d   10 489
r9d   10 499
r10d  10 4A9
r11d  10 4B9
r12d  10 4C9
r13d  10 4D9
r14d  10 4E9
r15d  10 4F9


'=================================
'end of data x86 registers
'=================================



'===
'END
'===
"


