
  '============
  'SEARCH FILES
  '============

  '22/03/2014
  '22:52 17/03/2017
  'Charles E V Pegge

  include  "SysUtil.inc"


  function StartOfLine(string*s,sys*i)
  ====================================
  byte *b=strptr s
  do
    if i=0 then exit do
    if b[i]=10 then exit do
    i--
  end do
  i++
  end sub


  function sample(string s, sys a,l,*b,*e)
  '=======================================
  b=a-l
  if b<1 then b=1
  e=a+l
  end function



  function search(string s, sys a, pk, mx) as sys
  '==============================================
  sys b,c,d,e,n,p,t
  if not s then return 0
  if pk=0 then return 0
  n=a
  string k at p 'array of keywords
  '
  NewSearch:
  '
  p=pk
  a=instr n,s,k 'first keyword
  n=a+len k
  t=0
  if a then
    sample s,a,200,b,e
    '
    'the other keywords nearby
    '
    do
      p+=sizeof(sys) 'advance pointer for next keyword string
      if ++t>mx then return a 'max keywords
      if not k then return a  'no more keywords
      c=instr b,s,k
      if c=0 or c>e then
        goto NewSearch
      end if
   end do
  end if
  end function



  function wordlist(string s, sys pk, sys n) as sys
  =================================================
  sys c,i 
  i=1
  string k at pk 'string array
  do
    k=getphrase s,i
    if not k then exit do
    if ++c>=n then exit do 'max list length
    pk+=4 'advance string array pointer
  end do
  return c
  end function



  function splitstring(string s, string d, sys pk, sys n) as sys
  ==============================================================
  '
  'itr not sensitive to quoted text
  '
  sys a,b,c,i,ld,ls,ex
  string k at pk 'string array
  ls=len s : if ls=0 then return 0
  ld=len d : if ld=0 then return 0
  b=1
  do
    a=instr b,s,d
    if a=0 then
      a=ls+1
      ex=1
    end if
    k=mid s,b,a-b
    if ex then return c
    if ++c>=n then return c 
    b=a+ld
    pk+=4 'advance pointer for next string element
  end do
  end function



  function SearchString(string s, w) as sys
  =========================================
  def MaxPhrases 32
  sys a=1,c
  string k[MaxPhrases]
  if not w then return 0
  c=wordlist w, @k, MaxPhrases
  a=search s,a,@k,c
  if a then
    return a
  end if
  '
  end function



  function KeywordPosList(string s, w) as string
  ==============================================
  def MaxPhrases 32
  sys a=1,c
  string k[MaxPhrases]
  string line
  sys pbo,le, t
  if not w then exit function
  c=wordlist w, @k, MaxPhrases
  string posbuf=nuls 0x2000
  do
    a=search s,a,@k,c
    if a then
      ++t 'counter
      if t>200 then exit do
      line=str(a)+cr
      le=len line
      if pbo+le>len(posbuf) then posbuf+=nuls 0x2000
      mid posbuf,pbo+1,line
      pbo+=le
    else
      exit do
    end if
    a++
  end do
  return left posbuf,pbo
  '
  end function



  function SearchFile(string f, w) as sys
  =========================================
  string s
  s=lcase getfile f
  if not s then
    'print f " file not found"
    return 0
  end if
  return SearchString s,w
  end function



  function dirpath(string d) as string
  ====================================
  sys a,b,i,e=len d
  do
    i++
    if i>e then exit do
    a=asc d,i
    if a=47 or a=92 then b=i
  end do
  if b then return left d,b
  end function



  function GetFilteredFileList(string filter,wordlist) as string
  ===================================================================
  WIN32_FIND_DATA f
  sys a,h,e,i
  zstring dirname[256]
  string dr=dirpath filter
  string fbuf=nuls 0x8000
  sys fbe,le,ld
  ld=len dr
  '
  'GetCurrentDirectory 256, @dirname
  'pr="Directory Name: " dirname cr "Filter: " filter cr cr
  '
  h=FindFirstFile filter, @f
  '
  if h then
    do
      a=0
      if not wordlist then
        a=1
      else
        if f.cfilename then 
          a=SearchFile dr+f.cFileName, wordlist
        end if
      end if
      '
      if a then
        i++
        le=ld+len(f.cFileName)+2
        if fbe+le>len fbuf then fbuf+=nuls 0x8000
        mid fbuf,fbe+1,dr+f.cFileName+cr
        fbe+=le
        'function+=dr f.cFileName cr
      end if
      e=FindNextFile h, @f
      if e=0 then
        e=GetLastError 'should be 18 when no more files
        'print e
        exit do
      end if
    end do
    FindClose h
  end if
  return left fbuf,fbe
  end function


  sub MakeFilterMembers(string *s,w)
  ================================
  sys a,b=1
  string r,lw,rw
  a=instrev(0,w,"\")
  rw=mid(w,a+1)
  lw=left(w,a)
  do
    a=instr(b,s,cr)
    if not a then exit do
    r=lw+mid(s,b,a-b)+"\"+rw
    s=left(s,b-1)+r+mid(s,a)
    b+=len(r)+2
  end do
  end sub
  

  function GetFilteredFileLists(string filterlist,wordlist) as string
  ===================================================================
  string filter, flist=filterlist, dlist, dfilt, fr
  sys a, b=1, c, en, ex, k, n
  '
  en=1+len filterlist
  '
  do
    a=instr b,flist,cr
    if a=0 then a=en : ex=1
    filter=ltrim rtrim mid flist, b,a-b
    if filter then
      c=asc(filter)
      if c<>39 then 'not a comment mark '
        if c=45 then
          'SWITCHES
          c=asc(filter,2)
          filter =ltrim mid filter,3
          if (c=82)or(c=114)or(c=83)or(c=115) then
            'get subdirectories and add to flist
            k=instrev(0,filter,"\")
            if k then
              dfilt=left(filter,k)+"*"
            else
              dfilt="*"
            end if
            dlist=GetFileList(dfilt,n,1)
            if dlist then
              if (c=82)or(c=114) then '-r recursive subdirectory searching
                fr="-r "
              else
                fr=""
              end if
              MakeFilterMembers dlist,fr+filter
              flist=left(flist,b-1)+dlist+mid(flist,a+2)
             a=b-2 ' offset adjust
            end if
            'check for subdirectory tree
            'recursive?
          end if
        end if
        function+=GetFilteredFileList filter, wordlist
      end if
    else
      ex=1 'blank line break
    end if
    if ex then exit do
    b=a+2
  end do
  end function
