'http://msdn.microsoft.com/en-us/library/windows/desktop/ms724390(v=vs.85).aspx
'http://msdn.microsoft.com/en-gb/library/windows/desktop/dd405535(v=vs.85).aspx

'https://msdn.microsoft.com/en-us/library/windows/desktop/ms682485(v=vs.85).aspx
'https://msdn.microsoft.com/en-us/library/windows/desktop/dd743609(v=vs.85).aspx


type SYSTEMTIME 
  word wYear,
       wMonth,
       wDayOfWeek,
       wDay,
       wHour,
       wMinute,
       wSecond,
       wMilliseconds
end type

extern lib "kernel32.dll"

  ! Sleep (sys msec)
  ! GetSystemTime (SYSTEMTIME*lpSystemTime)
  ! GetLocalTime  (SYSTEMTIME*lpSystemTime)
  ! GetTickCount() as sys
 '! GetTickCount64() as sys 'ulonglong vista 2008..
 '! QueryUnbiasedInterruptTime(quad*t) 'vista 2008..
 
  bool CreateTimerQueueTimer(
  sys*     phNewTimer,
  sys      TimerQueue=0,
  sys      Callback,
  sys      Parameter=0,
  dword    DueTime=0,
  dword    Period=100,
  dword    flags=0
  );

  bool DeleteTimerQueueTimer(
  sys TimerQueue=0,
  sys Timer,
  sys CompletionEvent=0
  );

extern lib "Winmm.dll"

extern
  'itr cdecl?
  'VOID CALLBACK WaitOrTimerCallback(
  'sys lpParameter,
  'bool TimerOrWaitFired
  ');
end extern

 macro longlongstore(t) addr ecx,t : mov [ecx],eax : mov [ecx+4],edx


  function TimeStr(optional SYSTEMTIME*tt,int md) as string
  =========================================================
  macro f(v) mid( "0"+str(v) , -2)
  macro m(v) mid("00"+str(v), -3)
  SYSTEMTIME u,*t
  if @tt=0 then GetLocalTime(u) : @t=@u else @t=@tt 
  function=str(t.wYear) +"-"+f(t.wMonth)+"-"+f(t.wDay)+
  " T "+f(t.wHour)+":"+f(t.wMinute)+":"+f(t.wSecond)
  if md then function+="."+left(m(t.wMilliseconds),md)
  end function


  function TimeLapseMs(SYSTEMTIME *t1,*t2) as sys
  ===============================================
  '<60 second timer
  sys td = t2.wMilliSeconds-t1.wMilliseconds+
  ((t2.wSecond-t1.wSecond)*1000)+
  ((t2.wMinute-t1.wMinute)*60000)+
  ((t2.wHour-t1.wHour)*3600000)+
  ((t2.wDayOfWeek-t1.wDayOfWeek)*86400000)
  '
  'end of week crossing
  if td<0 then td+=604800000
  return td
  end function

