

  '=======
  'GLOBALS
  '=======

  sys a
  string s

  'PICKER
  '======

  def    SelectBufSize 4096
  long   SelectBuf[SelectBufSize]
  sys    SelObject, hits
  sys    picklevel=1, nearest=1


  GLYPHMETRICSFLOAT gmf[1000]

  '
  'TIMING
  '======
  '
  quad   grtic1,grtic2,grtic3,grfreq
  double fps,grlap,agr,aspect
  sys    timerval  
  '
  'STATE VARIABLES
  '===============
  '
  sys    refresh,bselect,keyt,keyc,ReqShutDown,
         ldblclk,
         wWidth,wHeight,togsp,projmode,listr,objectr,
         acte, reqtex, focus,exclu,
         DrawingList, doredraw,
         isNewView=1,
         viewmode=StartMode,
         scenenum=StartScene

  'GL CONTEXT
  '==========
  '
  sys    hDC,hRC,
         shadows,shadowable,
         antialias, multisampling,
         nPixelFormat,ReqNewMode,arbMultisampleFormat,
         arbMultisampleSupported


  '
  'POSITIONAL
  '=========
  '
  sys    ppx,ppy,active_view

  single tra_x, tra_y, tra_z,             'OBJECT VIEW TRANSLATION
         rot_x, rot_y, rot_z, rot_ys=.25, 'OBJECT ROTATION AROUND AXIS
         sca_a=1,                         'OBJECT VIEW SCALE
         orthosize=3.0                    'ORTHOGRAPHIC VIEW SCALER


  'GENERAL
  '=======
  '
  sys    mapref[16]
  sys    ctrls[100]
  long   texn[32]    'texture names
  long   viewport[4] 'current viewport dimensions (pixel pos)
  string buftxt[128] 'line deletion buffer
  sys    bufti=1     'buffer index

  '
  'MATRIX
  '======
  '
  double modelview[16], projection[16]


  'STANDARD MATERIAL
  '=================

  single surface_ambient[4]  <= (MaterialAmbient),
         surface_diffuse[4]  <= (MaterialDiffuse),
         surface_specular[4] <= (MaterialSpecular),
         surface_shininess    = MaterialShininess

  'STANDARD LIGHTING
  '=================

  single light_position[4] <= (LightPosition),
         light_diffuse [4] <= (LightDiffuse),
         light_specular[4] <= (LightSpecular),
         light_ambient [4] <= (LightAmbient)




